;*********************************************************************************************************
;		Zyklengenaue Emulation eines MOS6510 auf einem ATmega
;			(c) Mark Leyer 2010
;*********************************************************************************************************




;*************************************************
;*************************************************

	; derzeitiger Kompromiss: ADC und SBC im Dezimal-Modus
	; 1 Takt mehr als im Datenblatt angegeben
	; daher wie bei CMOS-Variante Flags korrekt

;*************************************************
;*************************************************




; 13 Takte bis hier
; 2 Takte vor READ+2 rjmp sind 17
; bleiben 3 Takte vor Sprung, ergo D-flag-Abfrage hinter 2. READ


opcode_ADC:

	opcode_ADC_BCD:

;neu: ADC_helper1 = 0x06
;	  ADC_helper2 = 0x60

opcode_ADC_immed:
			nop
			LoadZ opc_ADC_immed_1
			rjmp read_immediate
	opc_ADC_immed_1:
			sbrs reg_Status2, flagD
			rjmp opc_ADC_Bin_1
			rjmp BCDadd



	opc_ADC_Bin_1:
			lsr reg_Status
			adc reg_A, opbyte2
			in reg_Status, SREG
			andi reg_Status, 0b00001111
			RWAIT 18
			rjmp main_loop
	


opcode_ADC_ZP:
			nop
			LoadZ opc_ADC_ZP_1
			rjmp read_ZP
	opc_ADC_ZP_1:
			sbrs reg_Status2, flagD
			rjmp opc_ADC_Bin_1
			rjmp BCDadd



opcode_ADC_ZPX:
			nop
			LoadZ opc_ADC_ZPX_1
			rjmp read_ZPX
	opc_ADC_ZPX_1:
			RWAIT 0
			sbrs reg_Status2, flagD
			rjmp opc_ADC_Bin_1
			rjmp BCDadd





opcode_ADC_Abs:
			nop
			LoadZ opc_ADC_Abs_1
			rjmp read_Absolute
	opc_ADC_Abs_1:
			sbrs reg_Status2, flagD
			rjmp opc_ADC_Bin_1
			rjmp BCDadd




opcode_ADC_Abs_X:
			nop
			LoadZ opc_ADC_Abs_X_1
			rjmp read_Absolute_X
	opc_ADC_Abs_X_1:
			sbrs reg_Status2, flagD
			rjmp opc_ADC_Bin_1
			rjmp BCDadd



opcode_ADC_Abs_Y:
			nop
			LoadZ opc_ADC_Abs_Y_1
			rjmp read_Absolute_Y
	opc_ADC_Abs_Y_1:
			sbrs reg_Status2, flagD
			rjmp opc_ADC_Bin_1
			rjmp BCDadd




opcode_ADC_InX:
			nop
			LoadZ opc_ADC_InX_1
			rjmp read_InX
	opc_ADC_InX_1:
			sbrs reg_Status2, flagD
			rjmp opc_ADC_Bin_1
			rjmp BCDadd


opcode_ADC_InY:
			nop
			LoadZ opc_ADC_InY_1
			rjmp read_InY
	opc_ADC_InY_1:
			sbrs reg_Status2, flagD
			rjmp opc_ADC_Bin_1
			rjmp BCDadd






BCDadd:	;bis hier 8 Takte weg
			lsr reg_Status		; C-flag ins Carry

			adc	reg_A, opbyte2				;add the numbers binary
			; Carry??
			;sbic SREG, SREG_C
			brcc add_1a

			set
		add_1a:;12 bis hier
			brhs add_1						;if half carry not set
			add	reg_A, ADC_helper1			;    add 6 to LSD
			brhs add_2						;    if half carry not set (LSD <= 9)
			subi reg_A, 0x06				; restore value
			;sbic SREG, SREG_C
			brcc add_1b
			set
			;swap temp
		add_1b:;18 bis hier
			add	reg_A, ADC_helper2			;add 6 to MSD
			brcs add_4a						;if carry not set (MSD <= 9)
			brts add_3a
			subi reg_A, 0x60				;	restore value
add_3a:
			RWAIT 9		;24+5-20
			rjmp main_loop					;else			24
add_4a:	
			sbr reg_Status2, flagV		;    set BCD carry
			RWAIT 9		;24+5-20
			rjmp main_loop					;24
		;je+ca5 fr SREG-Abfrage!!!


add_1:
			add	reg_A, ADC_helper1			;    add 6 to LSD
			nop;16
add_2:	
			;sbic SREG, SREG_C
			brcc add_2b
			set;5
		add_2b:
			;swap temp
			add	reg_A, ADC_helper2			;add 6 to MSD
			brcs add_4						;if carry not set (MSD <= 9)
			brts add_3
			subi reg_A, 0x60				;	restore value
add_3:
			RWAIT 9		;24+5-20
			rjmp main_loop					;+9
add_4:	
			sbr reg_Status2, flagV			;    set BCD carry???
			RWAIT 9		;24+5-20
			rjmp main_loop					;27+5 = 7zuviel
; je 24 Takte
; nach 20 READ_RDY? oder weglassen??
; flags setzen?



/*
;Dezimalmode??? Mark-Version:
			;mov temp, reg_A
			adc reg_A, oparand
			mov temp2, reg_A
			andi temp2, 0b00001111
			cpi temp2, 0x0A
			brsh nib1ovf
		nib2:
			mov temp2, reg_A
			andi temp2, 0b11110000
			cpi temp2, 0xA0
			brsh nib2ovf
		nib_end:
			;mov reg_A, temp
			tst reg_A
			in temp, SREG
			;...
			rjmp main_loop				;ca. 34+5 = 14zuviel!!!

		nib2ovf:
			ldi temp2, 0x90
			andi temp, 0b00001111
			or temp, temp2
			sbr reg_Status2, flagV
			tst reg_A
			in temp, SREG
			;...
			rjmp main_loop				;ca. 34+5 = 14zuviel!!!




		nib1ovf:
			ldi temp2, 0x09
			andi temp, 0b11110000
			or temp, temp2
			subi temp, -16
			mov temp2, reg_A
			andi temp2, 0b1111000
			cpi temp2, 0xA0
			brsh nib2ovf2
		nib_end2:
			;mov reg_A, temp
			tst reg_A
			in temp, SREG
			;...
			rjmp main_loop				;ca. 34+5 = 14zuviel!!!
		nib2ovf2:
			ldi temp2, 0x90
			andi temp, 0b00001111
			or temp, temp2
			sbr reg_Status2, flagV
			tst reg_A
			in temp, SREG
			;...
			rjmp main_loop				;ca. 34+5 = 14zuviel!!!




*/

;Atmel-Version
;	Register BCD1, BCD2, tmpadd

;			BCDadd:
;				ldi	tmpadd,6	;value to be added later
;				add	BCD1,BCD2	;add the numbers binary
;				clr	BCD2		;clear BCD carry
;				brcc	add_0		;if carry not clear
;				ldi	BCD2,1		;    set BCD carry
;			add_0:	brhs	add_1		;if half carry not set
;				add	BCD1,tmpadd	;    add 6 to LSD
;				brhs	add_2		;    if half carry not set (LSD <= 9)
;				subi	BCD1,6		;        restore value
;				rjmp	add_2		;else
;			add_1:	add	BCD1,tmpadd	;    add 6 to LSD
;			add_2:	brcc	add_2a
;				ldi	BCD2,1	
;			add_2a:	swap	tmpadd
;				add	BCD1,tmpadd	;add 6 to MSD
;				brcs	add_4		;if carry not set (MSD <= 9)
;				sbrs	BCD2,0		;    if previous carry not set
;				subi	BCD1,$60	;	restore value
;			add_3:	ret			;else
;			add_4:	ldi	BCD2,1		;    set BCD carry
;				ret


opcode_SBC:


opcode_SBC_immed:
			nop
			LoadZ opc_SBC_immed_1
			rjmp read_immediate
	opc_SBC_immed_1:
			sbrs reg_Status2, flagD
			rjmp opc_SBC_Bin_1
			rjmp BCD_sub



	opc_SBC_Bin_1:
			lsr reg_Status
			sbc reg_A, opbyte2
			in temp, SREG
			andi temp, 0b00001111
			RWAIT 18
			rjmp main_loop

opcode_SBC_ZP:
			nop
			LoadZ opc_SBC_ZP_1
			rjmp read_ZP
	opc_SBC_ZP_1:
			sbrs reg_Status2, flagD
			rjmp opc_SBC_Bin_1
			rjmp BCD_sub


opcode_SBC_ZPX:
			nop
			LoadZ opc_SBC_ZPX_1
			rjmp read_ZPX
	opc_SBC_ZPX_1:
			RWAIT 0
			sbrs reg_Status2, flagD
			rjmp opc_SBC_Bin_1
			rjmp BCD_sub


opcode_SBC_Abs:
			nop
			LoadZ opc_SBC_Abs_1
			rjmp read_Absolute
	opc_SBC_Abs_1:
			sbrs reg_Status2, flagD
			rjmp opc_SBC_Bin_1
			rjmp BCD_sub


opcode_SBC_Abs_X:
			nop
			LoadZ opc_SBC_Abs_X_1
			rjmp read_Absolute_X
	opc_SBC_Abs_X_1:
			sbrs reg_Status2, flagD
			rjmp opc_SBC_Bin_1
			rjmp BCD_sub


opcode_SBC_Abs_Y:
			nop
			LoadZ opc_SBC_Abs_Y_1
			rjmp read_Absolute_Y
	opc_SBC_Abs_Y_1:
			sbrs reg_Status2, flagD
			rjmp opc_SBC_Bin_1
			rjmp BCD_sub




opcode_SBC_InX:
			nop
			LoadZ opc_SBC_InX_1
			rjmp read_InX
	opc_SBC_InX_1:
			sbrs reg_Status2, flagD
			rjmp opc_SBC_Bin_1
			rjmp BCD_sub


opcode_SBC_InY:
			nop
			LoadZ opc_SBC_InY_1
			rjmp read_InY
	opc_SBC_InY_1:
			sbrs reg_Status2, flagD
			rjmp opc_SBC_Bin_1
			rjmp BCD_sub



BCD_sub:	;8 bis hier
			lsr reg_Status
			sbc	reg_A, oparand	;subtract the numbers binary
			clr	temp
			brcc sub_0		;if carry not clear
			ldi	temp,1		;    store carry in BCDB1, bit 0
sub_0:	
			brhc sub_1		;if half carry not clear
			subi reg_A,$06	;    LSD = LSD - 6
sub_1:
			sbrs temp,0		;if previous carry not set
			rjmp sub_3			;    return
			subi reg_A,$60	;subtract 6 from MSD
			ldi	temp,1		;set underflow carry
			brcc sub_2		;if carry not clear
			ldi	temp,1		;    clear underflow carry	
sub_2:	
			RWAIT 8
			rjmp main_loop;23

sub_3:
			WAIT3
			RWAIT 8
			rjmp main_loop
; Flags?????







