;*********************************************************************************************************
;		Zyklengenaue Emulation eines MOS6510 auf einem ATmega
;			(c) Mark Leyer 2010
;*********************************************************************************************************










opcode_CMP:

opc_CMP_1:
			cp reg_A, oparand
			in temp, SREG
			andi reg_Status, 0b11111000
			andi temp, 0b00000111
			or reg_Status, temp
			RWAIT 16
			rjmp main_loop


opcode_CMP_immed:
			nop
			LoadZ opc_CMP_1
			rjmp read_Immediate

opcode_CMP_ZP:
			nop
			LoadZ opc_CMP_1
			rjmp read_ZP

opcode_CMP_ZPX:
			nop
			LoadZ opc_CMP_1
			RWAIT 0
			rjmp read_ZPX

opcode_CMP_Abs:
			nop
			LoadZ opc_CMP_1
			rjmp read_Absolute

opcode_CMP_Abs_X:
			nop
			LoadZ opc_CMP_1
			rjmp read_Absolute_X
opcode_CMP_Abs_Y:
			nop
			LoadZ opc_CMP_1
			rjmp read_Absolute_Y

opcode_CMP_InX:
			nop
			LoadZ opc_CMP_1
			rjmp read_InX

opcode_CMP_InY:
			nop
			LoadZ opc_CMP_1
			rjmp read_InY




opcode_CPX:

opc_CPX_1:
			cp reg_X, oparand
			in temp, SREG
			andi reg_Status, 0b11111000
			andi temp, 0b00000111
			or reg_Status, temp
			RWAIT 16
			rjmp main_loop

opcode_CPX_immed:
			nop
			LoadZ opc_CPX_1
			rjmp read_Immediate

opcode_CPX_ZP:
			nop
			LoadZ opc_CPX_1
			rjmp read_ZP

opcode_CPX_Abs:
			nop
			LoadZ opc_CPX_1
			rjmp read_Absolute


opcode_CPY:

opc_CPY_1:
			cp reg_Y, oparand
			in temp, SREG
			andi reg_Status, 0b11111000
			andi temp, 0b00000111
			or reg_Status, temp
			RWAIT 16
			rjmp main_loop

opcode_CPY_immed:
			nop
			LoadZ opc_CPY_1
			rjmp read_Immediate

opcode_CPY_ZP:
			nop
			LoadZ opc_CPY_1
			rjmp read_ZP

opcode_CPY_Abs:
			nop
			LoadZ opc_CPY_1
			rjmp read_Absolute





opcode_BIT:

	opc_BIT_1:
			tst oparand
			in temp, SREG
			andi reg_Status, 0b11111001
			andi temp, 0b00000110
			or reg_Status, temp
			bst oparand, 0x06
			bld reg_Status, flagV			; oder entspricht AVR-V 6502-V???
			RWAIT 18
			rjmp main_loop

opcode_BIT_ZP:
			nop
			LoadZ opc_BIT_1
			rjmp read_ZP

opcode_BIT_Abs:
			nop
			LoadZ opc_BIT_1
			rjmp read_Absolute


















