;*********************************************************************************************************
;		Zyklengenaue Emulation eines MOS6510 auf einem ATmega
;			(c) Mark Leyer 2010
;*********************************************************************************************************






opcode_LDA:

	opc_LDA_1:
			mov reg_A, oparand
			andi reg_Status, 0b11111001
			tst reg_A
			in temp, SREG
			andi temp, 0b00000110
			or reg_Status, temp
			RWAIT 17
			rjmp main_loop
			

opcode_LDA_immed:
			nop
			LoadZ opc_LDA_1	;2
			rjmp read_Immediate	;2

opcode_LDA_ZP:
			nop
			LoadZ opc_LDA_1
			rjmp read_ZP

opcode_LDA_ZPX:
			nop
			LoadZ opc_LDA_1
			RWAIT 0
			rjmp read_ZPX

opcode_LDA_Abs:
			nop
			LoadZ opc_LDA_1
			rjmp read_Absolute

opcode_LDA_Abs_X:
			nop
			LoadZ opc_LDA_1
			rjmp read_Absolute_X	;2

opcode_LDA_Abs_Y:
			nop
			LoadZ opc_LDA_1
			rjmp read_Absolute_Y	;2

opcode_LDA_InX:
			nop
			LoadZ opc_LDA_1
			rjmp read_InX

opcode_LDA_InY:
			nop
			LoadZ opc_LDA_1
			rjmp read_InY



opcode_LDX:

	opc_LDX_1:
			mov reg_X, oparand
			andi reg_Status, 0b11111001
			tst reg_X
			in temp, SREG
			andi temp, 0b00000110
			or reg_Status, temp
			RWAIT 17
			rjmp main_loop
			

opcode_LDX_immed:
			nop
			LoadZ opc_LDX_1
			rjmp read_Immediate

opcode_LDX_ZP:
			nop
			LoadZ opc_LDX_1
			rjmp read_ZP

opcode_LDX_ZPY:
			nop
			LoadZ opc_LDX_1
			RWAIT 0
			rjmp read_ZPY

opcode_LDX_Abs:
			nop
			LoadZ opc_LDX_1
			rjmp read_Absolute

opcode_LDX_Abs_Y:
			nop
			LoadZ opc_LDX_1
			rjmp read_Absolute_Y	;2






opcode_LDY:

	opc_LDY_1:
			mov reg_Y, oparand
			andi reg_Status, 0b11111001
			tst reg_Y
			in temp, SREG
			andi temp, 0b00000110
			or reg_Status, temp
			RWAIT 17
			rjmp main_loop

opcode_LDY_immed:
			nop
			LoadZ opc_LDY_1
			rjmp read_Immediate

opcode_LDY_ZP:
			nop
			LoadZ opc_LDY_1
			rjmp read_ZP

opcode_LDY_ZPX:
			nop
			LoadZ opc_LDY_1
			RWAIT 0
			rjmp read_ZPX

opcode_LDY_Abs:
			nop
			LoadZ opc_LDY_1
			rjmp read_Absolute

opcode_LDY_Abs_X:
			nop
			LoadZ opc_LDY_1
			rjmp read_Absolute_X	;2






opcode_STA:

opcode_STA_ZP:
			nop
			nop
			mov oparand, reg_A
			rjmp write_ZP

opcode_STA_ZPX:
			nop
			nop
			mov oparand, reg_A
			RWAIT 0
			rjmp write_ZPX

opcode_STA_Abs:
			nop
			nop
			mov oparand, reg_A
			rjmp write_Absolute

opcode_STA_Abs_X:
			nop
			nop
			RWAIT 0
			mov oparand, reg_A
			rjmp write_Absolute_X

opcode_STA_Abs_Y:
			nop
			nop
			RWAIT 0
			mov oparand, reg_A
			rjmp write_Absolute_Y

opcode_STA_InX:
			nop
			nop
			mov oparand, reg_A
			rjmp write_InX

opcode_STA_InY:
			nop
			nop
			mov oparand, reg_A
			RWAIT 0				;????? nicht sicher
			rjmp write_InY



opcode_STX:

opcode_STX_ZP:
			nop
			nop
			mov oparand, reg_X
			rjmp write_ZP

opcode_STX_ZPY:
			nop
			nop
			mov oparand, reg_X
			RWAIT 0
			rjmp write_ZPY

opcode_STX_Abs:
			nop
			nop
			mov oparand, reg_X
			rjmp write_Absolute





opcode_STY:

opcode_STY_ZP:
			nop
			nop
			mov oparand, reg_Y
			rjmp write_ZP


opcode_STY_ZPX:
			nop
			nop
			mov oparand, reg_Y
			RWAIT 0
			rjmp write_ZPX


opcode_STY_Abs:
			nop
			nop
			mov oparand, reg_Y
			rjmp write_Absolute






















