;*********************************************************************************************************
;		Zyklengenaue Emulation eines MOS6510 auf einem ATmega
;			(c) Mark Leyer 2010
;*********************************************************************************************************







opcode_ORA:

	opc_ORA_1:
			or reg_A, oparand
			in temp, SREG
			andi reg_Status, 0b11111001
			andi temp, 0b00000110
			or reg_Status, temp
			RWAIT 16
			rjmp main_loop

opcode_ORA_immed:
			nop
			LoadZ opc_ORA_1
			rjmp read_Immediate

opcode_ORA_ZP:
			nop
			LoadZ opc_ORA_1
			rjmp read_ZP

opcode_ORA_ZPX:
			nop
			LoadZ opc_ORA_1
			RWAIT 0
			rjmp read_ZPX

opcode_ORA_Abs:
			nop
			LoadZ opc_ORA_1
			rjmp read_Absolute

opcode_ORA_Abs_X:
			nop
			LoadZ opc_ORA_1
			rjmp read_Absolute_X

opcode_ORA_Abs_Y:
			nop
			LoadZ opc_ORA_1
			rjmp read_Absolute_Y

opcode_ORA_InX:
			nop
			LoadZ opc_ORA_1
			rjmp read_InX

opcode_ORA_InY:
			nop
			LoadZ opc_ORA_1
			rjmp read_InY



opcode_AND:

	opc_AND_1:
			and reg_A, oparand
			in temp, SREG
			andi reg_Status, 0b11111001
			andi temp, 0b00000110
			or reg_Status, temp
			RWAIT 16
			rjmp main_loop


opcode_AND_immed:
			nop
			LoadZ opc_AND_1
			rjmp read_Immediate


opcode_AND_ZP:
			nop
			LoadZ opc_AND_1
			rjmp read_ZP

opcode_AND_ZPX:
			nop
			LoadZ opc_AND_1
			RWAIT 0
			rjmp read_ZPX

opcode_AND_Abs:
			nop
			LoadZ opc_AND_1
			rjmp read_Absolute

opcode_AND_Abs_X:
			nop
			LoadZ opc_AND_1
			rjmp read_Absolute_X

opcode_AND_Abs_Y:
			nop
			LoadZ opc_AND_1
			rjmp read_Absolute_Y

opcode_AND_InX:
			nop
			LoadZ opc_AND_1
			rjmp read_InX

opcode_AND_InY:
			nop
			LoadZ opc_AND_1
			rjmp read_InY



opcode_EOR:

	opc_EOR_1:
			eor reg_A, oparand
			in temp, SREG
			andi reg_Status, 0b11111001
			andi temp, 0b00000110
			or reg_Status, temp
			RWAIT 16
			rjmp main_loop

opcode_EOR_immed:
			nop
			LoadZ opc_EOR_1
			rjmp read_Immediate


opcode_EOR_ZP:
			nop
			LoadZ opc_EOR_1
			rjmp read_ZP

opcode_EOR_ZPX:
			nop
			LoadZ opc_EOR_1
			RWAIT 0
			rjmp read_ZPX

opcode_EOR_Abs:
			nop
			LoadZ opc_EOR_1
			rjmp read_Absolute

opcode_EOR_Abs_X:
			nop
			LoadZ opc_EOR_1
			rjmp read_Absolute_X

opcode_EOR_Abs_Y:
			nop
			LoadZ opc_EOR_1
			rjmp read_Absolute_Y

opcode_EOR_InX:
			nop
			LoadZ opc_EOR_1
			rjmp read_InX

opcode_EOR_InY:
			nop
			LoadZ opc_EOR_1
			rjmp read_InY















