;*********************************************************************************************************
;		Zyklengenaue Emulation eines MOS6510 auf einem ATmega
;			(c) Mark Leyer 2010
;*********************************************************************************************************







opcode_ASL:

opcode_ASL_accu:
			RWAIT 18
			READ_RDY
			lsl reg_A
			in temp, SREG
			andi reg_Status, 0b11111000
			andi temp, 0b00000111
			or reg_Status, temp
			RWAIT 9
			rjmp main_loop

opcode_ASL_ZP:
			;WAIT3
			nop
			LoadZ opc_ASL_ZP_1
			rjmp read_ZP

	opc_ASL_ZP_1:
			RWAIT 18
			lsl oparand
			in temp, SREG
			andi reg_Status, 0b11111000
			andi temp, 0b00000111
			or reg_Status, temp
			RWAIT 0
			rjmp mod_write_ZP

opcode_ASL_ZPX:
			;WAIT3
			nop
			LoadZ opc_ASL_ZP_1
			RWAIT 0
			rjmp read_ZPX

opcode_ASL_Abs:
			;WAIT3
			LoadZ opc_ASL_Abs_1
			andi reg_Status, 0b11111000
			rjmp read_Absolute

		opc_ASL_Abs_1:
			lsl oparand
			in temp, SREG
			andi temp, 0b00000111
			or reg_Status, temp
			RWAIT 0
			rjmp mod_write_Absolute

opcode_ASL_Abs_X:
			;WAIT3
			LoadZ opc_ASL_Abs_1
			andi reg_Status, 0b11111000
			RWAIT 0
			rjmp read_Absolute_X



opcode_ROL:

opcode_ROL_accu:
			RWAIT 18
			READ_RDY
			lsr reg_Status
			rol reg_A
			in temp, SREG
			lsl reg_Status					; V-Flag wieder herstellen
			andi reg_Status, 0b11111000
			andi temp, 0b00000111
			or reg_Status, temp
			RWAIT 11
			rjmp main_loop


opcode_ROL_ZP:
			;WAIT3
			nop
			LoadZ opc_ROL_ZP_1
			rjmp read_ZP

	opc_ROL_ZP_1:
			lsr reg_Status
			rol oparand
			in temp, SREG
			lsl reg_Status					; V-Flag wieder herstellen
			andi reg_Status, 0b11111000
			andi temp, 0b00000111
			or reg_Status, temp
			RWAIT 0
			rjmp mod_write_ZP

opcode_ROL_ZPX:
			;WAIT3
			nop
			LoadZ opc_ROL_ZP_1
			RWAIT 0
			rjmp read_ZPX

opcode_ROL_Abs:
			;WAIT3
			nop
			LoadZ opc_ROL_Abs_1
			rjmp read_Absolute

		opc_ROL_Abs_1:
			lsr reg_Status
			rol oparand
			in temp, SREG
			lsl reg_Status					; V-Flag wieder herstellen
			andi reg_Status, 0b11111000
			andi temp, 0b00000111
			or reg_Status, temp
			RWAIT 3
			rjmp mod_write_Absolute

			lsr reg_Status		; C-flag ins Carry
			rol oparand
			bld reg_status, 2
			in reg_Status, SREG
			andi reg_Status, 0b00000111
			bst reg_Status, 3
			rjmp mod_write_Absolute	;nur 8 statt 9 Takte!!



opcode_ROL_Abs_X:
			;WAIT3
			nop
			LoadZ opc_ROL_Abs_1
			RWAIT 0
			rjmp read_Absolute_X





opcode_LSR:

opcode_LSR_accu:
			RWAIT 18
			READ_RDY
			lsr reg_A
			in temp, SREG
			andi reg_Status, 0b11111000
			andi temp, 0b00000111
			or reg_Status, temp
			RWAIT 9
			rjmp main_loop

opcode_LSR_ZP:
			;WAIT3
			nop
			LoadZ opc_LSR_ZP_1
			rjmp read_ZP

	opc_LSR_ZP_1:
			RWAIT 18
			lsr oparand
			in temp, SREG
			andi reg_Status, 0b11111000
			andi temp, 0b00000111
			or reg_Status, temp
			RWAIT 0
			rjmp mod_write_ZP

opcode_LSR_ZPX:
			;WAIT3
			nop
			LoadZ opc_LSR_ZP_1
			RWAIT 0
			rjmp read_ZPX

opcode_LSR_Abs:
			;WAIT3
			LOADZ opc_LSR_Abs_1
			andi reg_Status, 0b11111000
			rjmp read_Absolute

		opc_LSR_Abs_1:
			lsr oparand
			in temp, SREG
			andi temp, 0b00000111
			or reg_Status, temp
			RWAIT 0
			rjmp mod_write_Absolute

opcode_LSR_Abs_X:
			RWAIT 0
			LOADZ opc_LSR_Abs_1
			andi reg_Status, 0b11111000
			rjmp read_Absolute_X





opcode_ROR:

opcode_ROR_accu:
			RWAIT 18
			READ_RDY
			lsr reg_Status
			ror reg_A
			in temp, SREG
			lsl reg_Status					; V-Flag wieder herstellen
			andi reg_Status, 0b11111000
			andi temp, 0b00000111
			or reg_Status, temp
			RWAIT 11
			rjmp main_loop

opcode_ROR_ZP:
			;WAIT3
			nop
			LoadZ opc_ROR_ZP_1
			rjmp read_ZP

	opc_ROR_ZP_1:
			lsr reg_Status
			ror oparand
			in temp, SREG
			lsl reg_Status					; V-Flag wieder herstellen
			andi reg_Status, 0b11111000
			andi temp, 0b00000111
			or reg_Status, temp
			RWAIT 0
			rjmp mod_write_ZP

opcode_ROR_ZPX:
			RWAIT 0
			nop
			LoadZ opc_ROR_ZP_1
			rjmp read_ZPX

opcode_ROR_Abs:
			;WAIT3
			nop
			LoadZ opc_ROR_Abs_1
			rjmp read_Absolute

		opc_ROR_Abs_1:
			lsr reg_Status
			ror oparand
			in temp, SREG
			lsl reg_Status					; V-Flag wieder herstellen
			andi reg_Status, 0b11111000
			andi temp, 0b00000111
			or reg_Status, temp
			RWAIT 3
			rjmp mod_write_Absolute

opcode_ROR_Abs_X:
			;WAIT3
			nop
			LoadZ opc_ROR_Abs_1
			RWAIT 0
			rjmp read_Absolute_X
