;*********************************************************************************************************
;		Zyklengenaue Emulation eines MOS6510 auf einem ATmega
;			(c) Mark Leyer 2010
;*********************************************************************************************************





opcode_BRK:
; was ist mit I_Flag????
			RWAIT 16
			sbr reg_Status2, flag_B
			READ_RDY		;?
			adiw reg_PCL, 0x01
			mov YL, reg_SP
			ldi YH, 0x01
			RWAIT 4
			st Y, reg_PCH
			dec YL
			RWAIT 3
			st Y, reg_PCL
			dec YL
			RWAIT 5		; noch Status!!
			; Status ummodeln
			READ_RDY
			mov temp, reg_Status2
			mov temp2, reg_Status
			andi temp2, 0b00000011
			or temp2, temp
			bld reg_Status, 0x02
			bst temp2, 0x07
			bld reg_Status, 0x03
			bst temp2, 0x06
			; I-Flag aus IO auslesen???
			dec YL
			mov reg_SP, YL
			RWAIT 10
			st Y, temp2

			RWAIT 9
			ldi YL, low (Vector6510NMI)
			ldi YH, high(Vector6510NMI)

			;**************
			;IRQ abfangen
			sei
			nop
			cli
			READ_RDY
			ld reg_PCL, Y+
			RWAIT 4
			READ_RDY
			ld reg_PCH, Y+
			RWAIT 9
			rjmp main_loop




opcode_JSR:
			RWAIT 15
			READ_RDY
			ld opbyte2, X+
			RWAIT 4
			READ_RDY
			ld opbyte3, X+


			mov YL, reg_SP
			ldi YH, 0x01
			RWAIT 4
			st Y, reg_PCH
			dec reg_SP
			RWAIT 3
			st -Y, reg_PCL
			dec reg_SP
			RWAIT 5

			READ_RDY
			mov reg_PCL, opbyte2
			mov reg_PCH, opbyte3
			RWAIT 9
			rjmp main_loop









opcode_RTI:
			inc reg_SP
			RWAIT 18
			mov YL, reg_SP
			ldi YH, 0x01
			READ_RDY
			ld reg_Status2, Y
			mov reg_Status, temp
			andi reg_Status, 0b00000011
			bld reg_Status2, 0x07
			bst reg_Status, 0x02
			bld reg_Status2, 0x06
			bst reg_Status, 0x03
			andi reg_Status2, 0b00011100
			RWAIT 13
			READ_RDY
			ld reg_PCL, Y
			inc YL
			RWAIT 5
			READ_RDY
			ld reg_PCH, Y
			inc YL
			mov reg_SP, YL
			RWAIT 6
			READ_RDY
			RWAIT 2
			READ_RDY
			RWAIT 2
			READ_RDY
			RWAIT 7
			rjmp main_loop








opcode_RTS:
			;ldi temp, 0x01
			;READ_EXT_RAM reg_SP, temp, reg_PCL
			;inc reg_SP
			;READ_EXT_RAM reg_SP, temp, reg_PCH
			;inc reg_SP
			;adiw reg_PCL, 0x01
			RWAIT 18
			mov YL, reg_SP
			ldi YH, 0x01
			inc YL
			READ_RDY
			ld reg_PCL, Y
			RWAIT 6
			inc YL
			nop
			READ_RDY
			ld reg_PCH, Y
			mov reg_SP, YL
			RWAIT 5
			READ_RDY
			RWAIT 2
			READ_RDY
			RWAIT 2
			READ_RDY
			RWAIT 7

			rjmp main_loop




opcode_NOP:
			RWAIT 15
			READ_RDY
			RWAIT 7
			rjmp main_loop






opcode_JMP:
			RWAIT 15
			READ_RDY
			ld temp, X+
			RWAIT 4
			READ_RDY
			ld temp2, X+
			mov reg_PCL, temp
			mov reg_PCH, temp2

			cpi opcode, 0x6C
			breq opcode_JMP_indirect

			RWAIT 13

			rjmp main_loop


		opcode_JMP_indirect:
			RWAIT 10
			movw YL, reg_PCL
			READ_RDY
			ld temp, Y+
			RWAIT 4
			READ_RDY
			ld temp2, Y
			mov reg_PCL, temp
			mov reg_PCH, temp2
			RWAIT 11
			rjmp main_loop


troedel1takt:
			RWAIT 18
			READ_RDY
			RWAIT 7
			rjmp main_loop

troedel1takt1:
			;RWAIT 18	;sbi+cbi je 2 Takte
			READ_RDY
			RWAIT 7
			rjmp main_loop


opcode_TAY:
			mov reg_Y, reg_A
			rjmp troedel1takt

opcode_TYA:
			mov reg_A, reg_Y
			rjmp troedel1takt

opcode_TXA:
			mov reg_A, reg_X
			rjmp troedel1takt

opcode_TAX:
			mov reg_X, reg_A
			rjmp troedel1takt



; Folgendes alles 2 Takte, nur 1 byte
;		Status2:		I	D	B	S	V	-	-	-
;		Status:			-	-	-	-	-	N	Z	C

opcode_CLC:
			cbr reg_Status, flag_C
			rjmp troedel1takt

opcode_SEC:
			sbr reg_Status, flag_C
			rjmp troedel1takt


	; zum Aktivieren des IRQ auf noch entsprechendes IO-Register setzen
opcode_CLI:
			cbr reg_Status2, flag_I
			;sbi IRQMask, IRQMPin		;2
			nop		; IRQ weglassen
			nop
			rjmp troedel1takt1
opcode_SEI:
			sbr reg_Status2, flag_I
			;cbi IRQMask, IRQMPin		;2
			nop		; IRQ weglassen
			nop
			rjmp troedel1takt1
opcode_CLV:
			cbr reg_Status, flag_V
			rjmp troedel1takt
opcode_CLD:
			cbr reg_Status2, flag_D
			rjmp troedel1takt
opcode_SED:
			sbr reg_Status2, flag_D
			rjmp troedel1takt

















