;*********************************************************************************************************
;		Zyklengenaue Emulation eines MOS6510 auf einem ATmega
;			(c) Mark Leyer 2010
;*********************************************************************************************************








read_Immediate:
			;adiw reg_PCL, 0x01
			;READ_EXT_RAM reg_PCL, reg_PCH, opbyte2		;6
			READ_RDY
			ld oparand, X+
			ijmp


read_Absolute:
		;erstmal nur Funktion, spter takten
		; Ablauf: READ op2, READ op3, Test auf 0x0000+0x0001, Read oparand
			READ_RDY
			ld opbyte2, X+		;L-byte
			RWAIT 4

			READ_RDY
			ld opbyte3, X+		;H-byte

			tst opbyte3
			breq read_Abs_1			; ZP-Zugriff

			RWAIT 8

			mov YL, opbyte2
			mov YH, opbyte3
			READ_RDY
			ld oparand, Y
			ijmp			;ges. 8, bleiben 9 Takte fr die Bearbeitung
		read_Abs_1:
			mov temp, opbyte2
			lsr temp
			breq read_Abs_2
			;ab hier normal ZP
			RWAIT 12
			mov YL, opbyte2
			;ldi YH, 0x00
			mov YH, ZP_Highbyte
			READ_RDY
			ld oparand, Y
			ijmp
		read_Abs_2:
			;ab hier Zugriff auf 0x0000 oder 0x0000
			tst opbyte2
			breq read_Abs_3
			RWAIT 13
			READ_RDY
			in oparand, CPU_DDR
			nop
			ijmp
		read_Abs_3:
			RWAIT 14
			READ_RDY
			in oparand, CPU_I
			nop
			ijmp


read_mod_Absolute:
	; ist eigentlich wie read_Absolute

write_Absolute:
			; Daten sollten in oparand stehen
			;READ_EXT_RAM reg_PCL, reg_PCH, opbyte2
			;adiw reg_PCL, 0x01
			;READ_EXT_RAM reg_PCL, reg_PCH, opbyte3
			;adiw reg_PCL, 0x01

			READ_RDY
			ld opbyte2, X+
			RWAIT 4
			READ_RDY
			ld opbyte3, X+
			RWAIT 14
			mov YL, opbyte2
			mov YH, opbyte3

mod_write_Absolute:
	;Adresse in opbyte2 und opbyte3 sowie YL + YH
	; je nach Taktung reicht vielleicht ein Sprung in die normale Write_Abs-Routine
			tst opbyte3
			breq write_Abs_1			; ZP-Zugriff
			; ab hier keine ZP: normal aus RAM lesen
			;WRITE_EXT_RAM opbyte2, opbyte3, oparand		;6
			WAIT8				; auf 10 Takte
			st Y, oparand
			RWAIT 9
			rjmp main_loop
		write_Abs_1:
			mov temp, opbyte2
			lsr temp
			breq write_Abs_2
			;ab hier normal ZP
			WAIT4
			st Y, oparand
			RWAIT 9
			rjmp main_loop
		write_Abs_2:
			;ab hier Zugriff auf 0x0000 oder 0x0000
			tst opbyte2
			breq write_Abs_3
			nop
			out CPU_DDR, oparand
			RWAIT 8
			rjmp main_loop
		write_Abs_3:
			out CPU_I, oparand
			RWAIT 8
			rjmp main_loop



read_mod_Absolute_Y:


read_Absolute_Y:
; wie read_Absolute, nur mit add reg_Y
;	und evtl. Artezyklus bei berlauf
			;READ_EXT_RAM reg_PCL, reg_PCH, opbyte2
			;adiw reg_PCL, 0x01
			;READ_EXT_RAM reg_PCL, reg_PCH, opbyte3
			;adiw reg_PCL, 0x01
			READ_RDY
			ld opbyte2, X+
			RWAIT 4
			READ_RDY
			ld opbyte3, X+

			add opbyte2, reg_Y
			brcs read_Abs_Y_warte1
		read_Abs_Y_0:
			tst opbyte3
			breq read_Abs_Y_1			; ZP-Zugriff
			; ab hier keine ZP: normal aus RAM lesen
			;READ_EXT_RAM opbyte2, opbyte3, oparand		;6
			mov YL, opbyte2
			mov YH, opbyte3
			RWAIT 8
			ld oparand, Y
			ijmp			;ges. 8, bleiben 9 Takte fr die Bearbeitung
		read_Abs_Y_warte1:
			;25 Takte warten inkl. Sprnge
			RWAIT 7
			READ_RDY
			WAIT2
			rjmp read_Abs_Y_0
		read_Abs_Y_1:
			mov temp, opbyte2
			lsr temp
			breq read_Abs_Y_2
			;ab hier normal ZP
			;READ_EXT_RAM opbyte2, zero, oparand
			mov YL, opbyte2
			mov YH, ZP_Highbyte
			RWAIT 12
			ld oparand, Y
			ijmp
		read_Abs_Y_2:
			;ab hier Zugriff auf 0x0000 oder 0x0000
			tst opbyte2
			breq read_Abs_Y_3
			RWAIT 15
			READ_RDY
			in oparand, CPU_DDR
			nop
			ijmp
		read_Abs_Y_3:
			RWAIT 16
			READ_RDY
			in oparand, CPU_I
			nop
			ijmp








write_Absolute_Y:
;     Write instructions (STA, STX, STY, SHA, SHX, SHY)
			;READ_EXT_RAM reg_PCL, reg_PCH, opbyte2
			;adiw reg_PCL, 0x01
			;READ_EXT_RAM reg_PCL, reg_PCH, opbyte3
			;adiw reg_PCL, 0x01
			READ_RDY
			ld opbyte2, X+
			RWAIT 4
			READ_RDY
			ld opbyte3, X+

			add opbyte2, reg_Y
			brcs write_Abs_Y_warte1
			RWAIT 16
			rjmp mod_write_Absolute

		write_Abs_Y_warte1:
			;25 Takte warten inkl. Sprnge
			RWAIT 7
			READ_RDY
			RWAIT 12
			rjmp mod_write_Absolute


read_mod_Absolute_X:


read_Absolute_X:
; wie read_Absolute, nur mit add reg_Y
;	und evtl. Artezyklus bei berlauf
			READ_RDY
			ld opbyte2, X+
			RWAIT 4

			READ_RDY
			ld opbyte3, X+

			add opbyte2, reg_X
			brcs read_Abs_X_warte1
		read_Abs_X_0:
			tst opbyte3
			breq read_Abs_X_1			; ZP-Zugriff
			; ab hier keine ZP: normal aus RAM lesen
			;READ_EXT_RAM opbyte2, opbyte3, oparand		;6
			mov YL, opbyte2
			mov YH, opbyte3
			RWAIT 8
			ld oparand, Y
			ijmp			;ges. 11, bleiben 6 Takte fr die Bearbeitung
		read_Abs_X_warte1:
			;25 Takte warten inkl. Sprnge
			RWAIT 7
			READ_RDY
			nop
			nop
			rjmp read_Abs_X_0
		read_Abs_X_1:	;7
			mov temp, opbyte2
			lsr temp
			breq read_Abs_X_2
			;ab hier normal ZP
			;READ_EXT_RAM opbyte2, zero, oparand
			mov YL, opbyte2
			mov YH, ZP_Highbyte
			RWAIT 12
			ld oparand, Y
			ijmp
		read_Abs_X_2:
			;ab hier Zugriff auf 0x0000 oder 0x0000
			tst opbyte2
			breq read_Abs_X_3
			RWAIT 15
			READ_RDY
			in oparand, CPU_DDR
			nop
			ijmp
		read_Abs_X_3:
			RWAIT 16
			READ_RDY
			in oparand, CPU_I
			nop
			ijmp


write_Absolute_X:
			READ_RDY
			ld opbyte2, X+
			RWAIT 4
			READ_RDY
			ld opbyte3, X+

			add opbyte2, reg_X
			brcs write_Abs_X_warte1
			RWAIT 16
			rjmp mod_write_Absolute


		write_Abs_X_warte1:
			;25 Takte warten inkl. Sprnge
			RWAIT 7
			READ_RDY
			RWAIT 12
			rjmp mod_write_Absolute



read_ZP:
		;wie vor, nur ohne switch
		;erstmal nur Funktion, spter takten
		;evtl. Rcksprung nicht ber ret, sondern IJMP
		; Ablauf: READ op2, Test auf 0x0000+0x0001, Read oparand
			;READ_EXT_RAM reg_PCL, reg_PCH, opbyte2
			;adiw reg_PCL, 0x01
			READ_RDY
			ld opbyte2, X+
		read_ZP_1:
			mov temp, opbyte2
			lsr temp
			breq read_ZP_2
			;ab hier normal ZP
			RWAIT 9
			;READ_EXT_RAM opbyte2, zero, oparand		;6
			mov YL, opbyte2
			mov YH, ZP_Highbyte
			READ_RDY
			ld oparand, Y
			ijmp
		read_ZP_2:
			;ab hier Zugriff auf 0x0000 oder 0x0000
			tst opbyte2
			breq read_ZP_3
			RWAIT 10
			READ_RDY
			in oparand, CPU_DDR
			nop
			ijmp
		read_ZP_3:
			RWAIT 11
			READ_RDY
			in oparand, CPU_I
			nop
			ijmp












write_ZP:
		;wie vor, nur ohne switch
		;erstmal nur Funktion, spter takten
		;evtl. Rcksprung nicht ber ret, sondern IJMP
		; Ablauf: READ op2, Test auf 0x0000+0x0001, Read oparand
			;READ_EXT_RAM reg_PCL, reg_PCH, opbyte2
			;adiw reg_PCL, 0x01
			READ_RDY
			ld opbyte2, X+
			RWAIT 9
mod_write_ZPX:
mod_write_ZP:
			mov temp, opbyte2
			lsr temp
			breq write_ZP_2
			;ab hier normal ZP
			nop
			nop
			mov YL, opbyte2
			mov YH, ZP_Highbyte
			st Y, oparand
			RWAIT 9
			rjmp main_loop
		write_ZP_2:
			;ab hier Zugriff auf 0x0000 oder 0x0000
			tst opbyte2
			breq write_ZP_3
			nop
			out CPU_DDR, oparand
			nop
			RWAIT 9
			rjmp main_loop
		write_ZP_3:	;7
			out CPU_O, oparand
			nop
			RWAIT 9
			rjmp main_loop



read_ZPX:
		;wie vor, nur ohne switch
		;erstmal nur Funktion, spter takten
		;evtl. Rcksprung nicht ber ret, sondern IJMP
		; Ablauf: READ op2, Test auf 0x0000+0x0001, Read oparand
			;READ_EXT_RAM reg_PCL, reg_PCH, opbyte2
			;adiw reg_PCL, 0x01
			READ_RDY
			ld opbyte2, X+
			RWAIT 12
		read_ZPX_1:
			add opbyte2, reg_X
			mov temp, opbyte2
			lsr temp
			breq read_ZPX_2
			;ab hier normal ZP
			
			
			mov YL, opbyte2
			mov YH, ZP_Highbyte
			nop
			nop
			READ_RDY
			ld oparand, Y
			ijmp
		read_ZPX_2:
			;ab hier Zugriff auf 0x0000 oder 0x0001
			tst opbyte2
			breq read_ZPX_3
			nop
			READ_RDY
			in oparand, CPU_DDR
			nop
			ijmp
		read_ZPX_3:
			READ_RDY
			in oparand, CPU_I
			nop
			ijmp

read_ZPY:
			;READ_EXT_RAM reg_PCL, reg_PCH, opbyte2
			;adiw reg_PCL, 0x01
			READ_RDY
			ld opbyte2, X+
			RWAIT 12
		read_ZPY_1:
			add opbyte2, reg_Y
			mov temp, opbyte2

			lsr temp
			breq read_ZPX_2
			;ab hier normal ZP
			nop
			nop
			;READ_EXT_RAM opbyte2, zero, oparand
			mov YL, opbyte2
			mov YH, ZP_Highbyte
			READ_RDY
			ld oparand, Y
			ijmp




write_ZPX:
	;eigentlich nur STA, STY, (SAX)
	; daher problemlos Rcksprung zu main_loop direkt von hier
		;wie vor, nur ohne switch
		;erstmal nur Funktion, spter takten
		; Ablauf: READ op2, Test auf 0x0000+0x0001, Read oparand
			;READ_EXT_RAM reg_PCL, reg_PCH, opbyte2
			;adiw reg_PCL, 0x01
			READ_RDY
			ld opbyte2, X+
			RWAIT 12
			add opbyte2, reg_X
			rjmp mod_write_ZP

write_ZPY:
	;eigentlich nur fr STX
			;READ_EXT_RAM reg_PCL, reg_PCH, opbyte2
			;adiw reg_PCL, 0x01
			READ_RDY
			ld opbyte2, X+
			RWAIT 12
			add opbyte2, reg_Y
			rjmp mod_write_ZP








read_InX:
			;READ_EXT_RAM reg_PCL, reg_PCH, opbyte2
			;adiw reg_PCL, 0x01
			READ_RDY
			ld opbyte2, X+							; ++++++++++++++++++++
			RWAIT 11
			; check auf 0+1
			mov temp, opbyte2
			lsl temp
			breq read_InX_1

			;READ_EXT_RAM opbyte2, zero, opbyte3
			mov YL, opbyte2
			mov YH, ZP_Highbyte
			nop
			nop
			READ_RDY
			ld opbyte3, Y							;+++++++++++++++++++++

			rjmp read_InX_2
		read_InX_1:
			tst opbyte2
			breq read_InX_1_1
			nop
			READ_RDY
			in opbyte3, CPU_DDR						; +++++++++++++++++++
			nop
			rjmp read_InX_2
		read_InX_1_1:
			READ_RDY
			in opbyte3, CPU_I						; ++++++++++++++++++++
			WAIT3

		read_InX_2:
			RWAIT 14
			add opbyte3, reg_X
			mov temp, opbyte3
			lsl temp
			breq read_InX_2_1
			;READ_EXT_RAM opbyte3, zero, temp2
			mov opbyte3, YL
			mov YH, ZP_Highbyte
			nop
			nop
			READ_RDY
			ld temp2, Y								;+++++++++++++++++++
			rjmp read_InX_3
		read_InX_2_1:
			tst opbyte3
			breq read_InX_2_2
			nop
			READ_RDY
			in temp2, CPU_DDR						; +++++++++++++++++++++++++
			nop
			rjmp read_InX_3
		read_InX_2_2:
			READ_RDY
			in temp2, CPU_I							; +++++++++++++++++++++++++
			WAIT3


		read_InX_3:
			RWAIT 14
			inc opbyte3
			mov temp, opbyte3
			lsl temp
			breq read_InX_3_1
			;READ_EXT_RAM opbyte3, zero, opbyte2
			mov YL, opbyte3
			mov YH, ZP_Highbyte
			nop
			nop
			READ_RDY
			ld opbyte2, Y							; ++++++++++++++++++++++
			rjmp read_InX_4
		read_InX_3_1:
			tst opbyte3
			breq read_InX_3_2
			nop
			READ_RDY
			in opbyte2, cpu_DDR						; +++++++++++++++++++++++++++
			nop
			rjmp read_InX_4
		read_InX_3_2:
			READ_RDY
			in opbyte2, CPU_I						; ++++++++++++++++++++++++++++++
			WAIT3

		read_InX_4:;auf12
			;Adresse in temp2 + oparand
			RWAIT 16
			tst opbyte2
			breq read_InX_4_1		; ZP_Adresse!
			;READ_EXT_RAM temp2, opbyte2, oparand
			mov YL, temp2
			mov YH, opbyte2
			WAIT6
			READ_RDY
			ld oparand, Y							; ++++++++++++++++++++++++++++
			ijmp
		read_InX_4_1:
			mov temp, temp2
			lsl temp
			breq read_InX_4_2
			;READ_EXT_RAM temp2, zero, oparand
			mov YL, temp2
			mov YH, ZP_Highbyte
			nop
			nop
			READ_RDY
			ld oparand, Y							; +++++++++++++++++++++++++++
			ijmp
		read_InX_4_2:
			tst temp2
			breq read_InX_4_3
			nop
			READ_RDY
			in oparand, CPU_DDR						; +++++++++++++++++++
			nop
			ijmp
		read_InX_4_3:
			READ_RDY
			in oparand, CPU_I						; +++++++++++++++++++++
			nop
			ijmp

			



; erstmal auslassen, sind nur illegale Ops











write_InX:
	; gilt ja eigentlich nur fr STA
	; trotzdem Daten in oparand, nicht nur reg_A
			;READ_EXT_RAM reg_PCL, reg_PCH, opbyte2
			;adiw reg_PCL, 0x01
			READ_RDY
			ld opbyte2, X+
			RWAIT 11
			; check auf 0+1
			mov temp, opbyte2
			lsl temp
			breq write_InX_1

			;READ_EXT_RAM opbyte2, zero, opbyte3
			mov YL, opbyte2
			mov YH, ZP_Highbyte
			nop
			nop
			READ_RDY
			ld opbyte3, Y
			rjmp write_InX_2
		write_InX_1:
			tst opbyte2
			breq write_InX_1_1
			nop
			READ_RDY
			in opbyte3, CPU_DDR
			nop
			rjmp write_InX_2
		write_InX_1_1:
			READ_RDY
			in opbyte3, CPU_I
			WAIT3

		write_InX_2:
			RWAIT 14
			add opbyte3, reg_X
			mov temp, opbyte3
			lsl temp
			breq write_InX_2_1
			;READ_EXT_RAM opbyte3, zero, temp2
			mov YL, opbyte3
			mov YH, ZP_Highbyte
			nop
			nop
			READ_RDY
			ld temp2, Y
			rjmp write_InX_3
		write_InX_2_1:
			tst opbyte3
			breq write_InX_2_2
			nop
			READ_RDY
			in temp2, CPU_DDR
			nop
			rjmp write_InX_3
		write_InX_2_2:
			READ_RDY
			in temp2, CPU_I
			WAIT3

		write_InX_3:
			RWAIT 14
			inc opbyte3
			mov temp, opbyte3
			lsl temp
			breq write_InX_3_1
			;READ_EXT_RAM opbyte3, zero, opbyte2
			mov YL, opbyte3
			mov YH, ZP_Highbyte
			nop
			nop
			READ_RDY
			ld opbyte2, Y
			rjmp write_InX_4
		write_InX_3_1:
			tst opbyte3
			breq write_InX_3_2
			nop
			READ_RDY
			in opbyte2, cpu_DDR
			nop
			rjmp write_InX_4
		write_InX_3_2:
			READ_RDY
			in opbyte2, CPU_I
			WAIT3

		write_InX_4:
			RWAIT 14
			;Adresse in temp2 + oparand
			tst opbyte2
			breq write_InX_4_1		; ZP_Adresse!
			;WRITE_EXT_RAM temp2, opbyte2, oparand
			mov Yl, temp2
			mov YH, opbyte2
			WAIT6
			st Y, oparand
			RWAIT 9
			rjmp main_loop
		write_InX_4_1:
			mov temp, temp2
			lsl temp
			breq write_InX_4_2
			;WRITE_EXT_RAM temp2, zero, oparand
			mov YL, temp2
			mov YH, ZP_Highbyte
			nop
			nop
			st Y, oparand
			RWAIT 9
			rjmp main_loop
		write_InX_4_2:
			tst temp2
			breq write_InX_4_3
			nop
			out CPU_DDR, oparand
			RWAIT 8
			rjmp main_loop
		write_InX_4_3:
			out CPU_O, oparand
			RWAIT 8
			rjmp main_loop















read_InY:
			;READ_EXT_RAM reg_PCL, reg_PCH, opbyte2
			;adiw reg_PCL, 0x01
			READ_RDY
			ld opbyte2, X+
			RWAIT 11
			mov temp, opbyte2
			lsl temp
			breq read_InY_1
			;READ_EXT_RAM opbyte2, zero, opbyte3
			mov YL, opbyte2
			mov YH, ZP_Highbyte
			nop
			nop
			READ_RDY
			ld opbyte3, Y
			rjmp read_InY_2
		read_InY_1:
			tst opbyte2
			breq read_InY_1_1
			nop
			READ_RDY
			in opbyte3, CPU_I
			nop
			rjmp read_InY_2
		read_InY_1_1:
			READ_RDY
			in opbyte3, CPU_DDR
			WAIT3

		read_InY_2:
			RWAIT 14
			inc opbyte2
			mov temp, opbyte2
			lsl temp
			breq read_InY_2_1
			;READ_EXT_RAM opbyte2, zero, temp2
			mov YL, opbyte2
			mov YH, ZP_Highbyte
			nop
			nop
			READ_RDY
			ld temp2, Y
			rjmp read_InY_3

		read_InY_2_1:
			tst opbyte2
			breq read_InY_2_2
			nop
			READ_RDY
			in temp2, CPU_I
			nop
			rjmp read_InY_3
		read_inY_2_2:
			READ_RDY
			in temp2, CPU_DDR
			WAIT3

		read_InY_3:
			RWAIT 18
			add opbyte3, reg_Y
			brcs read_InY_3_warte
		read_InY_3_0:
			tst temp2
			breq read_InY_3_1
			; normaler Zugriff
			;READ_EXT_RAM opbyte3, temp2, oparand
			mov YL, opbyte3
			mov YH, temp2
			WAIT6
			READ_RDY
			ld oparand, Y
			ijmp

		read_InY_3_warte:
			WAIT8
			inc temp2
			READ_RDY
			RWAIT 14
			rjmp read_InY_3_0

		read_InY_3_1:
			mov temp, opbyte3
			lsl temp
			breq read_InY_3_2
			nop
			nop
			mov YL, opbyte3
			mov YH, ZP_Highbyte
			READ_RDY
			ld oparand, Y
			ijmp
		read_InY_3_2:
			tst opbyte3
			breq read_InY_3_3
			nop
			READ_RDY
			in oparand, CPU_I
			nop
			ijmp
		read_InY_3_3:
			READ_RDY
			in oparand, CPU_DDR
			nop
			ijmp








/*
write_InY:
			;READ_EXT_RAM reg_PCL, reg_PCH, opbyte2
			;adiw reg_PCL, 0x01
			READ_RDY
			ld opbyte2, X+

			mov temp, opbyte2
			lsl temp
			breq write_InY_1
			;READ_EXT_RAM opbyte2, zero, opbyte3
			mov YL, opbyte2
			clr YH
			READ_RDY
			ld opbyte3, Y
			rjmp write_InY_2
		write_InY_1:
			tst opbyte2
			breq write_InY_1_1
			in opbyte3, CPU_I
			rjmp write_InY_2
		write_InY_1_1:
			in opbyte3, CPU_DDR

		write_InY_2:
			inc opbyte2
	;****************
	; noch Warten einfgen bei C
	;****************
			mov temp, opbyte2
			lsl temp
			breq write_InY_2_1
			;READ_EXT_RAM opbyte2, zero, temp2
			mov YL, opbyte2
			clr YH
			ld temp2, Y
			rjmp write_InY_3
		write_InY_2_1:
			tst opbyte2
			breq write_InY_2_2
			in temp2, CPU_I
			rjmp write_InY_3
		write_inY_2_2:
			in temp2, CPU_DDR

		write_InY_3:
			tst temp2
			breq write_InY_3_1
			; normaler Zugriff
			;WRITE_EXT_RAM opbyte3, temp2, oparand
			mov YL, opbyte3
			mov YH, temp2
			st Y, oparand
			rjmp main_loop
		write_InY_3_1:
			mov temp, opbyte3
			lsl temp
			breq write_InY_3_2
			;WRITE_EXT_RAM opbyte3, zero, oparand
			mov YL, opbyte3
			clr YH
			st Y, oparand
			rjmp main_loop
		write_InY_3_2:
			tst opbyte3
			breq write_InY_3_3
			out CPU_O, oparand
			rjmp main_loop
		write_InY_3_3:
			out CPU_DDR, oparand
			rjmp main_loop
*/



write_InY:
			;READ_EXT_RAM reg_PCL, reg_PCH, opbyte2
			;adiw reg_PCL, 0x01
			READ_RDY
			ld opbyte2, X+
			RWAIT 11
			mov temp, opbyte2
			lsl temp
			breq write_InY_1
			;READ_EXT_RAM opbyte2, zero, opbyte3
			mov YL, opbyte2
			mov YH, ZP_Highbyte
			nop
			nop
			READ_RDY
			ld opbyte3, Y
			rjmp write_InY_2
		write_InY_1:
			tst opbyte2
			breq write_InY_1_1
			nop
			READ_RDY
			in opbyte3, CPU_I
			nop
			rjmp write_InY_2
		write_InY_1_1:
			READ_RDY
			in opbyte3, CPU_DDR
			WAIT3

		write_InY_2:
			RWAIT 14
			inc opbyte2
			mov temp, opbyte2
			lsl temp
			breq write_InY_2_1
			;READ_EXT_RAM opbyte2, zero, temp2
			mov YL, opbyte2
			mov YH, ZP_Highbyte
			nop
			nop
			READ_RDY
			ld temp2, Y
			rjmp write_InY_3

		write_InY_2_1:
			tst opbyte2
			breq write_InY_2_2
			nop
			READ_RDY
			in temp2, CPU_I
			nop
			rjmp write_InY_3
		write_inY_2_2:
			READ_RDY
			in temp2, CPU_DDR
			WAIT3

		write_InY_3:
			RWAIT 16
			add opbyte3, reg_Y
			brcs write_InY_3_warte
		write_InY_3_0:
			tst temp2
			breq write_InY_3_1
			; normaler Zugriff
			;READ_EXT_RAM opbyte3, temp2, oparand
			mov YL, opbyte3
			mov YH, temp2
			WAIT6
			;READ_RDY
			st Y, oparand
			RWAIT 9
			rjmp main_loop

		write_InY_3_warte:
			WAIT8
			inc temp2
			READ_RDY
			RWAIT 14
			rjmp write_InY_3_0

		write_InY_3_1:
			mov temp, opbyte3
			lsl temp
			breq write_InY_3_2
			nop
			nop
			mov YL, opbyte3
			mov YH, ZP_Highbyte
			;READ_RDY
			st Y, oparand
			RWAIT 9
			rjmp main_loop
		write_InY_3_2:
			tst opbyte3
			breq write_InY_3_3
			nop
			;READ_RDY
			out CPU_I, oparand
			RWAIT 8
			rjmp main_loop
		write_InY_3_3:
			;READ_RDY
			out CPU_DDR, oparand
			RWAIT 8
			rjmp main_loop













