;*********************************************************************************************************
;		Zyklengenaue Emulation eines MOS6510 auf einem ATmega
;			(c) Mark Leyer 2010
;*********************************************************************************************************




/*







									Code	Time
opcodes_table:
rjmp opcode_BRK			;0x00
rjmp opcode_ORA_InX
rjmp opcode_INVAL		;			erl.
rjmp opcode_SLO			;			erl.
rjmp opcode_NOP			;			erl.
rjmp opcode_ORA_ZP		;			erl.
rjmp opcode_ASL_ZP		;			erl.
rjmp opcode_SLO			;			erl.
rjmp opcode_PHP			;			erl.
rjmp opcode_ORA_immed	;			erl.
rjmp opcode_ASL_accu	;			erl.
rjmp opcode_SZP_immed	;			erl.		********************* neuer Opcode!!!!
rjmp opcode_NOP			;			erl.
rjmp opcode_ORA_Abs		;			erl.
rjmp opcode_ASL_Abs		;			erl.
rjmp opcode_SLO			;0x0F		erl.

rjmp opcode_BPL			;0x10		erl.
rjmp opcode_ORA_InY
rjmp opcode_INVAL		;			erl.
rjmp opcode_SLO			;			erl.
rjmp opcode_NOP			;			erl.
rjmp opcode_ORA_ZPX		;			erl.
rjmp opcode_ASL_ZPX		;			erl.
rjmp opcode_SLO			;			erl.
rjmp opcode_CLC			;			erl.
rjmp opcode_ORA_Abs_Y	;			erl.
rjmp opcode_NOP			;			erl.
rjmp opcode_SLO			;			erl.
rjmp opcode_NOP			;			erl.
rjmp opcode_ORA_Abs_X	;			erl.
rjmp opcode_ASL_Abs_X	;			erl.
rjmp opcode_SLO			;0x1F


rjmp opcode_JSR			;0x20
rjmp opcode_AND_InX
rjmp opcode_INVAL		;			erl.
rjmp opcode_RLA			;			erl.
rjmp opcode_BIT
rjmp opcode_AND_ZP		;			erl.
rjmp opcode_ROL_ZP		;			erl.
rjmp opcode_RLA			;			erl.
rjmp opcode_PLP			;			erl.
rjmp opcode_AND_immed	;			erl.
rjmp opcode_ROL_accu	;			erl.
rjmp opcode_ANC			;			erl.
rjmp opcode_BIT
rjmp opcode_AND_Abs		;			erl.
rjmp opcode_ROL_Abs		;			erl.
rjmp opcode_RLA			;0x2F		erl.


rjmp opcode_BMI			;0x30		erl.
rjmp opcode_AND_InY
rjmp opcode_INVAL		;			erl.
rjmp opcode_RLA			;			erl.
rjmp opcode_NOP			;			erl.
rjmp opcode_AND_ZPX		;			erl.
rjmp opcode_ROL_ZPX		;			erl.
rjmp opcode_RLA			;			erl.
rjmp opcode_SEC			;			erl.
rjmp opcode_AND_Abs_Y	;			erl.
rjmp opcode_NOP			;			erl.
rjmp opcode_RLA			;			erl.
rjmp opcode_NOP			;			erl.
rjmp opcode_AND_Abs_X	;			erl.
rjmp opcode_ROL_Abs_X	;			erl.
rjmp opcode_RLA			;0x3F		erl.

rjmp opcode_RTI			;0x40
rjmp opcode_EOR_InX
rjmp opcode_INVAL		;			erl.
rjmp opcode_SRE			;			erl.
rjmp opcode_NOP			;			erl.
rjmp opcode_EOR_ZP		;			erl.
rjmp opcode_LSR_ZP		;			erl.
rjmp opcode_SRE			;			erl.
rjmp opcode_PHA			;			erl.
rjmp opcode_EOR_immed	;			erl.
rjmp opcode_LSR_accu	;			erl.
rjmp opcode_ASR			;			erl.
rjmp opcode_JMP
rjmp opcode_EOR_Abs		;			erl.
rjmp opcode_LSR_Abs		;			erl.
rjmp opcode_SRE			;0x4F		erl.

rjmp opcode_BVC			;0x50		erl.
rjmp opcode_EOR_InY
rjmp opcode_INVAL		;			erl.
rjmp opcode_SRE			;			erl.
rjmp opcode_NOP			;			erl.
rjmp opcode_EOR_ZPX		;			erl.
rjmp opcode_LSR_ZPX		;			erl.
rjmp opcode_SRE			;			erl.
rjmp opcode_CLI			;			erl.
rjmp opcode_EOR_Abs_Y	;			erl.
rjmp opcode_NOP			;			erl.
rjmp opcode_SRE			;			erl.
rjmp opcode_NOP			;			erl.
rjmp opcode_EOR_Abs_X	;			erl.
rjmp opcode_LSR_Abs_X	;			erl.
rjmp opcode_SRE			;0x5F		erl.

rjmp opcode_RTS			;0x60
rjmp opcode_ADC_InX
rjmp opcode_INVAL		;			erl.
rjmp opcode_RRA			;			erl.
rjmp opcode_NOP			;			erl.
rjmp opcode_ADC_ZP
rjmp opcode_ROR_ZP		;			erl.
rjmp opcode_RRA			;			erl.
rjmp opcode_PLA			;			erl.
rjmp opcode_ADC_immed
rjmp opcode_ROR_accu	;			erl.
rjmp opcode_ARR			;			erl.
rjmp opcode_JMP
rjmp opcode_ADC_Abs
rjmp opcode_ROR_Abs		;			erl.
rjmp opcode_RRA			;0x6F		erl.

rjmp opcode_BVS			;0x70		erl.
rjmp opcode_ADC_InY
rjmp opcode_INVAL		;			erl.
rjmp opcode_RRA			;			erl.
rjmp opcode_NOP			;			erl.
rjmp opcode_ADC_ZPX
rjmp opcode_ROR_ZP		;			erl.
rjmp opcode_RRA			;			erl.
rjmp opcode_SEI			;			erl.
rjmp opcode_ADC_Abs_Y
rjmp opcode_NOP			;			erl.
rjmp opcode_RRA			;			erl.
rjmp opcode_NOP			;			erl.
rjmp opcode_ADC_Abs_X
rjmp opcode_ROR_Abs_X	;			erl.
rjmp opcode_RRA			;0x7F		erl.

rjmp opcode_NOP			;0x80		erl. 
rjmp opcode_STA_InX
rjmp opcode_NOP			;			erl.
rjmp opcode_SAX			;			erl.
rjmp opcode_STY_ZP		;			erl.
rjmp opcode_STA_ZP 		;			erl. 
rjmp opcode_STX_ZP		;			erl.
rjmp opcode_SAX			;			erl.
rjmp opcode_DEY			;			erl.  
rjmp opcode_NOP			;			erl. 
rjmp opcode_TXA  		;			erl.
rjmp opcode_ANE			;			erl.
rjmp opcode_STY_Abs		;			erl.  
rjmp opcode_STA_Abs		;			erl.  	OK
rjmp opcode_STX_Abs 	;			erl. 
rjmp opcode_SAX			;0x8F 

rjmp opcode_BCC			;0x90		erl.
rjmp opcode_STA_InY
rjmp opcode_INVAL		;			erl.
rjmp opcode_SHA			;			erl.
rjmp opcode_STY_ZPX		;			erl.
rjmp opcode_STA_ZPX		;			erl.
rjmp opcode_STX_ZPY		;			erl.
rjmp opcode_SAX			;			erl.
rjmp opcode_TYA			;			erl.
rjmp opcode_STA_Abs_Y	;			erl.
rjmp opcode_TXS			;			erl.
rjmp opcode_SHS			;			erl.
rjmp opcode_SHY			;			erl.
rjmp opcode_STA_Abs_X	;			erl.
rjmp opcode_SHX			;			erl.
rjmp opcode_SHA			;			erl.


rjmp opcode_LDY_immed	;0xA0		erl.	OK
rjmp opcode_LDA_InX
rjmp opcode_LDX_immed	;			erl.	OK
rjmp opcode_LAX			;			erl.
rjmp opcode_LDY_ZP		;			erl.
rjmp opcode_LDA_ZP		;			erl.
rjmp opcode_LDX_ZP		;			erl.
rjmp opcode_LAX			;			erl.
rjmp opcode_TAY			;			erl.
rjmp opcode_LDA_immed	;			erl.	OK
rjmp opcode_TAX			;			erl.
rjmp opcode_LXA			;			erl.
rjmp opcode_LDY_Abs		;			erl.
rjmp opcode_LDA_Abs		;			erl.
rjmp opcode_LDX_Abs		;			erl.
rjmp opcode_LAX			;0xAF

rjmp opcode_BCS			;0xB0
rjmp opcode_LDA
rjmp opcode_INVAL		;			erl.
rjmp opcode_LAX			;			erl.
rjmp opcode_LDY_ZPX		;			erl.
rjmp opcode_LDA_ZPX		;			erl.
rjmp opcode_LDX_ZPY		;			erl.
rjmp opcode_LAX			;			erl.
rjmp opcode_CLV			;			erl.
rjmp opcode_LDA_Abs_Y	;			erl.
rjmp opcode_TSX			;			erl.
rjmp opcode_LAS			;			erl.
rjmp opcode_LDY_Abs_X	;			erl.
rjmp opcode_LDA_Abs_X	;			erl.
rjmp opcode_LDX_Abs_Y	;			erl.
rjmp opcode_LAX			;0xBF

rjmp opcode_CPY_immed	;0xC0
rjmp opcode_CMP_InX
rjmp opcode_NOP			;			erl.
rjmp opcode_DCP			;			erl.
rjmp opcode_CPY_ZP		;			erl.
rjmp opcode_CMP_ZP		;			erl.
rjmp opcode_DEC_ZP		;			erl.
rjmp opcode_DCP			;			erl.
rjmp opcode_INY			;			erl.
rjmp opcode_CMP_immed	;			erl.
rjmp opcode_DEX			;			erl.
rjmp opcode_SBX			;			erl.
rjmp opcode_CPY_Abs		;			erl.
rjmp opcode_CMP_Abs		;			erl.
rjmp opcode_DEC_Abs		;			erl.
rjmp opcode_DCP			;0xCF		erl.

rjmp opcode_BNE			;0xD0		erl.
rjmp opcode_CMP_InY
rjmp opcode_INVAL		;			erl.
rjmp opcode_DCP			;			erl.
rjmp opcode_NOP			;			erl.
rjmp opcode_CMP_ZPX		;			erl.
rjmp opcode_DEC_ZPX		;			erl.
rjmp opcode_DCP			;			erl.
rjmp opcode_CLD			;			erl.
rjmp opcode_CMP_Abs_Y	;			erl.
rjmp opcode_NOP			;			erl.
rjmp opcode_DCP			;			erl.
rjmp opcode_NOP			;			erl.
rjmp opcode_CMP_Abs_X	;			erl.
rjmp opcode_DEC_Abs_X	;			erl.
rjmp opcode_DCP			;0xDF		erl.


rjmp opcode_CPX_immed	;0xE0		erl.
rjmp opcode_SBC_InX
rjmp opcode_NOP			;			erl.
rjmp opcode_ISB			;			erl.
rjmp opcode_CPX_ZP		;			erl.
rjmp opcode_SBC_ZP
rjmp opcode_INC_ZP		;			erl.
rjmp opcode_ISB			;			erl.
rjmp opcode_INX			;			erl.
rjmp opcode_SBC_immed
rjmp opcode_NOP			;			erl.
rjmp opcode_SBC
rjmp opcode_CPX_Abs		;			erl.
rjmp opcode_SBC_Abs
rjmp opcode_INC_Abs		;			erl.
rjmp opcode_ISB			;			erl.

rjmp opcode_BEQ			;0xF0		erl.
rjmp opcode_SBC_InY
rjmp opcode_INVAL		;			erl.
rjmp opcode_ISB			;			erl.
rjmp opcode_NOP			;			erl.
rjmp opcode_SBC_ZPX
rjmp opcode_INC_ZPX		;			erl.
rjmp opcode_ISB			;			erl.
rjmp opcode_SED			;			erl.
rjmp opcode_SBC_Abs_Y
rjmp opcode_NOP			;			erl.
rjmp opcode_ISB			;			erl.
rjmp opcode_NOP			;			erl.
rjmp opcode_SBC_Abs_X
rjmp opcode_INC_Abs_X	;			erl.
rjmp opcode_ISB			;0xFF		erl.






































*/
